// Auto-generated. Do not edit!

// (in-package rc_pick_client.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Box = require('./Box.js');
let Rectangle = require('./Rectangle.js');
let CellFillingLevel = require('./CellFillingLevel.js');
let GridSize = require('./GridSize.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class LoadCarrierWithFillingLevel {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.id = null;
      this.outer_dimensions = null;
      this.inner_dimensions = null;
      this.rim_thickness = null;
      this.pose = null;
      this.overfilled = null;
      this.overall_filling_level = null;
      this.cells_filling_levels = null;
      this.filling_level_cell_count = null;
    }
    else {
      if (initObj.hasOwnProperty('id')) {
        this.id = initObj.id
      }
      else {
        this.id = '';
      }
      if (initObj.hasOwnProperty('outer_dimensions')) {
        this.outer_dimensions = initObj.outer_dimensions
      }
      else {
        this.outer_dimensions = new Box();
      }
      if (initObj.hasOwnProperty('inner_dimensions')) {
        this.inner_dimensions = initObj.inner_dimensions
      }
      else {
        this.inner_dimensions = new Box();
      }
      if (initObj.hasOwnProperty('rim_thickness')) {
        this.rim_thickness = initObj.rim_thickness
      }
      else {
        this.rim_thickness = new Rectangle();
      }
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('overfilled')) {
        this.overfilled = initObj.overfilled
      }
      else {
        this.overfilled = false;
      }
      if (initObj.hasOwnProperty('overall_filling_level')) {
        this.overall_filling_level = initObj.overall_filling_level
      }
      else {
        this.overall_filling_level = new CellFillingLevel();
      }
      if (initObj.hasOwnProperty('cells_filling_levels')) {
        this.cells_filling_levels = initObj.cells_filling_levels
      }
      else {
        this.cells_filling_levels = [];
      }
      if (initObj.hasOwnProperty('filling_level_cell_count')) {
        this.filling_level_cell_count = initObj.filling_level_cell_count
      }
      else {
        this.filling_level_cell_count = new GridSize();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type LoadCarrierWithFillingLevel
    // Serialize message field [id]
    bufferOffset = _serializer.string(obj.id, buffer, bufferOffset);
    // Serialize message field [outer_dimensions]
    bufferOffset = Box.serialize(obj.outer_dimensions, buffer, bufferOffset);
    // Serialize message field [inner_dimensions]
    bufferOffset = Box.serialize(obj.inner_dimensions, buffer, bufferOffset);
    // Serialize message field [rim_thickness]
    bufferOffset = Rectangle.serialize(obj.rim_thickness, buffer, bufferOffset);
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [overfilled]
    bufferOffset = _serializer.bool(obj.overfilled, buffer, bufferOffset);
    // Serialize message field [overall_filling_level]
    bufferOffset = CellFillingLevel.serialize(obj.overall_filling_level, buffer, bufferOffset);
    // Serialize message field [cells_filling_levels]
    // Serialize the length for message field [cells_filling_levels]
    bufferOffset = _serializer.uint32(obj.cells_filling_levels.length, buffer, bufferOffset);
    obj.cells_filling_levels.forEach((val) => {
      bufferOffset = CellFillingLevel.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [filling_level_cell_count]
    bufferOffset = GridSize.serialize(obj.filling_level_cell_count, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type LoadCarrierWithFillingLevel
    let len;
    let data = new LoadCarrierWithFillingLevel(null);
    // Deserialize message field [id]
    data.id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [outer_dimensions]
    data.outer_dimensions = Box.deserialize(buffer, bufferOffset);
    // Deserialize message field [inner_dimensions]
    data.inner_dimensions = Box.deserialize(buffer, bufferOffset);
    // Deserialize message field [rim_thickness]
    data.rim_thickness = Rectangle.deserialize(buffer, bufferOffset);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [overfilled]
    data.overfilled = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [overall_filling_level]
    data.overall_filling_level = CellFillingLevel.deserialize(buffer, bufferOffset);
    // Deserialize message field [cells_filling_levels]
    // Deserialize array length for message field [cells_filling_levels]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.cells_filling_levels = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.cells_filling_levels[i] = CellFillingLevel.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [filling_level_cell_count]
    data.filling_level_cell_count = GridSize.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.id.length;
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.pose);
    length += 96 * object.cells_filling_levels.length;
    return length + 177;
  }

  static datatype() {
    // Returns string type for a message object
    return 'rc_pick_client/LoadCarrierWithFillingLevel';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '8df51d8f73786bbb32f9d962edc85ce9';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This represents a detected load carrier with it's filling level
    
    string id
    
    # Required
    Box outer_dimensions
    
    # Required
    Box inner_dimensions
    
    # Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
    Rectangle rim_thickness
    
    geometry_msgs/PoseStamped pose
    
    # True if a detected load carrier is overfilled. Ignored on setting load carrier.
    bool overfilled
    
    # Filling level of the whole load carrier
    CellFillingLevel overall_filling_level
    
    # Filling level of each load carrier cell
    CellFillingLevel[] cells_filling_levels
    
    GridSize filling_level_cell_count
    
    ================================================================================
    MSG: rc_pick_client/Box
    # Definition of a box
    
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: rc_pick_client/Rectangle
    # Definition of a rectangle
    
    float64 x
    float64 y
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: rc_pick_client/CellFillingLevel
    # Dimensions of the 2D cell in meters
    Rectangle cell_size
    
    # Position of the cell center in meters (either in camera or external pose frame)
    # The z-coordinate is on the level of the load carrier rim
    geometry_msgs/Point cell_position
    
    # Filling level of the cell in percent (100% represents a full cell)
    RangeValue level_in_percent
    
    # Free space of the cell in meters (how much space is left until the cell is full)
    RangeValue level_free_in_meters
    
    # Represents the percentage of valid pixels in this cell. Between 0 and 1 
    float64 coverage
    
    ================================================================================
    MSG: rc_pick_client/RangeValue
    float64 min
    float64 max
    float64 mean
    
    ================================================================================
    MSG: rc_pick_client/GridSize
    uint32 x
    uint32 y
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new LoadCarrierWithFillingLevel(null);
    if (msg.id !== undefined) {
      resolved.id = msg.id;
    }
    else {
      resolved.id = ''
    }

    if (msg.outer_dimensions !== undefined) {
      resolved.outer_dimensions = Box.Resolve(msg.outer_dimensions)
    }
    else {
      resolved.outer_dimensions = new Box()
    }

    if (msg.inner_dimensions !== undefined) {
      resolved.inner_dimensions = Box.Resolve(msg.inner_dimensions)
    }
    else {
      resolved.inner_dimensions = new Box()
    }

    if (msg.rim_thickness !== undefined) {
      resolved.rim_thickness = Rectangle.Resolve(msg.rim_thickness)
    }
    else {
      resolved.rim_thickness = new Rectangle()
    }

    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.PoseStamped.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.overfilled !== undefined) {
      resolved.overfilled = msg.overfilled;
    }
    else {
      resolved.overfilled = false
    }

    if (msg.overall_filling_level !== undefined) {
      resolved.overall_filling_level = CellFillingLevel.Resolve(msg.overall_filling_level)
    }
    else {
      resolved.overall_filling_level = new CellFillingLevel()
    }

    if (msg.cells_filling_levels !== undefined) {
      resolved.cells_filling_levels = new Array(msg.cells_filling_levels.length);
      for (let i = 0; i < resolved.cells_filling_levels.length; ++i) {
        resolved.cells_filling_levels[i] = CellFillingLevel.Resolve(msg.cells_filling_levels[i]);
      }
    }
    else {
      resolved.cells_filling_levels = []
    }

    if (msg.filling_level_cell_count !== undefined) {
      resolved.filling_level_cell_count = GridSize.Resolve(msg.filling_level_cell_count)
    }
    else {
      resolved.filling_level_cell_count = new GridSize()
    }

    return resolved;
    }
};

module.exports = LoadCarrierWithFillingLevel;
